# -*- coding:utf-8 -*-

# PyStnNews - a modification of "PyStationNews"
# SYMBIAN_UID = 0xE21357C1
__scriptname__ = 'PyStationNews'
__version__ = '0.3.1'
__author__ =  'masa'
__copyright__ = ' (c) 2013-2014 masa'
# web = "http://masaland.cocolog-nifty.com/"


"""
Original program(PyStationNews) was written by Mr.Hiisi. 
Please see below  about original license.

This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.


-----original license---------------------------------------
PyStationNews
SYMBIAN_UID = 0xEA1AA127
SIS_VERSION = '0.2.0'
Copyright (c) 2008-2009 Hiisi (hiisi.proxy@gmail.com)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
"""

Debug_in  = 0 #*
Debug_out = 0 #*
# Debug output file
#   E:/Data/Newstest0.htm

import sys
sys.setdefaultencoding('utf-8')
sys.path.insert(0, 'E:\\Python\\lib')

import e32
import os
import os.path
import socket
import urllib
import appuifw

try:
    import ConfigParser
except:
    appuifw.note(unicode('ConfigParserモジュールが見つかりません。'), 'error')
    raise
try:
    import appswitch
    ISAPPSWITCH = 1
    def switch_to_fg():
#        appswitch.switch_to_fg(u'PyStation News')
        appswitch.switch_to_fg(u'PyStnNews')
    def switch_to_bg():
#        appswitch.switch_to_bg(u'PyStation News')
        appswitch.switch_to_bg(u'PyStnNews')
except ImportError:
    ISAPPSWITCH = 0
try:
    import waplib
    ISWAPLIB = 1
except ImportError:
    ISWAPLIB = 0
try:
    import japanese
    try:
        japanese.aliases.encodings.aliases.aliases['sjis'] = \
         'japanese.shift_jis_docomo'
        '\xf8\x9f'.decode('sjis')
        
    except:
        raise ImportError
except ImportError:
    appuifw.note(u'JapaneseCodecs+emojiが見つかりません。', 'error', 1)
    raise


# カレンダー追加
ADD_MEMO = 0
# 新着ダイアログ
NOTIFY_NEW = 1
# Notify 用サウンドファイル
SOUND_FILE = u'E:\\Data\\Hiisi\\PyStation\\notify.mp3'
# Notify 用サウンドのボリューム
SOUND_VOL = 3
# 新着ありのとき、PyStnNews.html をみるクエリーを出すか否か
VIEW_QUERY = 0

class ConfigError(Exception):
    """設定エラー"""
    def __init__(self):
        pass
    def __str__(self):
        return repr(u'Configuration is incomplete.')

# データフォルダ
DATA_PATH = u'E:\\Data\\Hiisi\\PyStation'
if not os.path.exists(DATA_PATH):
    DATA_PATH = u'C:\\Data\\Hiisi\\PyStation'
    if not os.path.isdir(DATA_PATH):
        # データ保存に利用するドライブを選択
        drives = []
        if u'C:' in e32.drive_list():
            drives.append(u'C:\\Data\\Hiisi\\PyStation')
        if u'E:' in e32.drive_list():
            drives.append(u'E:\\Data\\Hiisi\\PyStation')
        drive = appuifw.popup_menu(drives,
                                   unicode('設定データ保存場所'))
        if drive == 0:
            DATA_PATH = u'C:\\Data\\Hiisi\\PyStation'
        elif drive == 1:
            DATA_PATH = u'E:\\Data\\Hiisi\\PyStation'
        else:
            appuifw.note(unicode('設定ファイルを作成できません。'), 'error')
            raise ConfigError
        try:
            os.makedirs(DATA_PATH)
        except OSError:
            appuifw.note(unicode('設定ファイルを作成できません。'), 'error')
            raise

# 設定ファイル
CFG_FILE = os.path.join(DATA_PATH, u'PyStation.cfg')
if os.path.isfile(CFG_FILE):
    cfg = ConfigParser.ConfigParser()
    cfg.read(CFG_FILE)
    write_f = ''
    try:
        APID = int(cfg.get('PyStation', 'APID'))
    except (ConfigParser.NoSectionError):
        APID = socket.select_access_point()
        if APID:
            cfg.add_section('PyStation')
            cfg.set('PyStation', 'APID', APID)
            write_f = 1
        else:
            raise ConfigError
    except (ConfigParser.NoOptionError):
        APID = socket.select_access_point()
        if APID:
            cfg.set('PyStation', 'APID', APID)
            write_f = 1
        else:
            raise ConfigError
    except:
        raise

    for n in range(4):
        try:
            if   n==0: NOTIFY_NEW = int(cfg.get('PyStation News', 'NOTIFY_NEW'))
            elif n==1: SOUND_VOL  = int(cfg.get('PyStation News', 'SOUND_VOL'))
            elif n==2: VIEW_QUERY = int(cfg.get('PyStation News', 'VIEW_QUERY'))
            elif n==3: ADD_MEMO   = int(cfg.get('PyStation News', 'ADD_MEMO'))
        except (ConfigParser.NoSectionError):
            cfg.add_section('PyStation News')
            cfg.set('PyStation News', 'NOTIFY_NEW', NOTIFY_NEW)
            cfg.set('PyStation News', 'SOUND_VOL', SOUND_VOL)
            cfg.set('PyStation News', 'VIEW_QUERY', VIEW_QUERY)
            cfg.set('PyStation News', 'ADD_MEMO', ADD_MEMO)
            write_f = 1
            break
        except (ConfigParser.NoOptionError):
            continue
        except:
            raise

    if write_f:
        f = open(CFG_FILE, 'w')
        cfg.write(f)
        f.close()

else:
    try:
        APID = socket.select_access_point()
        if APID:
            cfg = ConfigParser.ConfigParser()
            cfg.add_section('PyStation')
            cfg.set('PyStation', 'APID', APID)
            cfg.add_section('PyStation News')
            cfg.set('PyStation News', 'NOTIFY_NEW', NOTIFY_NEW)
            cfg.set('PyStation News', 'SOUND_VOL', SOUND_VOL)
            cfg.set('PyStation News', 'VIEW_QUERY', VIEW_QUERY)
            cfg.set('PyStation News', 'ADD_MEMO', ADD_MEMO)
            f = open(CFG_FILE, 'w')
            cfg.write(f)
            f.close()
        else:
            raise ConfigError
    except:
        raise


# バックグラウンドに移動
if ISAPPSWITCH: switch_to_bg()

# 出力HTMLファイル
OUT_FILE = os.path.join(DATA_PATH, u'%s.html' % __scriptname__)
#if os.path.exists(OUT_FILE):
if 1:
    try:
        f = open(OUT_FILE, 'w')
        f.write(unicode('<?xml version="1.0"?>\r\n'))
        f.write(unicode('<!DOCTYPE HTML PUBLIC "-//W3C//DTD XHTML 1.1//EN" '))
        f.write(unicode('"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">\r\n'))
        f.write(unicode('<html xmlns="http://www.w3.org/1999/xhtml" '))
        f.write(unicode('xml:lang="ja">\r\n'))
        f.write(unicode('<head>\r\n'))
        f.write(unicode('<meta http-equiv="Content-Type" '))
        f.write(unicode('content="text/html; charset=UTF-8" />\r\n'))
        f.write(unicode('<title>PyStation News</title>\r\n'))
        f.write(unicode('</head>\r\n'))
        f.write(unicode('<body>\r\n'))
        f.write(unicode('<h1>新着ニュース</h1>\r\n'))
        f.write(unicode('<p>接続エラー！もう一度接続してください。</p>\r\n'))
        f.write(unicode('<p>通信環境、設定、接続先サイトの仕様変更などについてチェックして下さい。</p>\r\n'))
        f.write(unicode('<hr />\r\n'))
        f.write(unicode('<p><a href="./PyStation.html">戻る</a></p>\r\n'))
        f.write(unicode('</body>\r\n'))
        f.write(unicode('</html>'))
        f.close()
    except IOError:
        pass

#既に表示した（古い）ニュースの記憶ファイル
News_File = os.path.join(DATA_PATH, u'News.txt')

NEWS_URL = 'http://news.j-walker.jp/'
NEWS_URL_P1 = 'http://news.j-walker.jp/index.php?&p=1'
NEWS_URL_P2 = 'http://news.j-walker.jp/index.php?&p=2'
NEWS_URL_P3 = 'http://news.j-walker.jp/index.php?&p=3'

def fetch():
    """ニュースを取得する"""
    if ISWAPLIB and APID == waplib.APID_WAP:
        waplib.wap_connection({'Accept-Charset': 'Shift_JIS'})
    ap = socket.access_point(APID)
    socket.set_default_access_point(ap)

    try:
        if not Debug_in: #*
            f = urllib.urlopen(NEWS_URL_P1)
            data = f.read()
            f.close()
            f = urllib.urlopen(NEWS_URL_P2)
            data = data + f.read()
            f.close()
            f = urllib.urlopen(NEWS_URL_P3)
            data = data + f.read()
            f.close()
        else:
            F = open('E:\\Data\\Newstest0.htm')
            data = F.read()
            F.close()

        if Debug_out and not Debug_in: #*
            F = open('E:\\Data\\Newstest0.htm', 'w')
            F.write(data)
            F.close()
        data = data.decode('sjis')
        return data
    except:
#        raise
        return None

def parse(data):
    """ニュースを取り出す"""
    import re
    newsdata = re.findall(
      unicode(
        '<a href="/index\.php\?d=(\d+)\&w=(\d).+?=">(.+?)</a>(.\(\d+:\d+\))'),
        data )

    #News_File : 既に表示した（古い）ニュースの記憶ファイル
    if os.path.isfile(News_File):
        F = open(News_File, 'r')
        wk = F.read()
        F.close()
        wk = wk.decode('utf-8')
        olditems = [x for x in wk.split(u"\n") if len(x) > 1]
    else:
        olditems = []

    wk1 = [] #work, next old items
    latests  = [] #新着ニュース
    lastnews = [] #今回も受信したが、前回既にあったニュース

    for x in newsdata:
        if (x[2]+x[3]) not in olditems:
            latests.append(x) #old_itemsにないニュース（新着）を取り出す
        else:
            lastnews.append(x) #old_itemsにあるニュース

    if latests: #新着ニュースあり
        for x in latests:
            wk1.append(x[2]+x[3])
        for x in olditems:
            wk1.append(x)
        if len(wk1) > 30:
            olditems = wk1[:30]
        else:
            olditems = wk1[:]

    F = open(News_File, 'w')
    for x in olditems:
        F.write(x + "\n")
    F.close()

    year, month, day, hour, minute, sec = get_time()
#    if os.path.exists(OUT_FILE):
    if 1:
        try:
            f = open(OUT_FILE, 'w')
            f.write(unicode('<?xml version="1.0"?>\r\n'))
            f.write(unicode('<!DOCTYPE HTML PUBLIC '))
            f.write(unicode('"-//W3C//DTD XHTML 1.1//EN" '))
            f.write(unicode('"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">'))
            f.write(unicode('\r\n'))
            f.write(unicode('<html xmlns="http://www.w3.org/1999/xhtml" '))
            f.write(unicode('xml:lang="ja">\r\n'))
            f.write(unicode('<head>\r\n'))
            f.write(unicode('<meta http-equiv="Content-Type" '))
            f.write(unicode('content="text/html; charset=UTF-8" />\r\n'))
            f.write(unicode('<title>PyStation News</title>\r\n'))
            f.write(unicode('</head>\r\n'))
            f.write(unicode('<body>\r\n'))
#            f.write(unicode('<h2>新着ニュース</h2>\r\n'))
            f.write(unicode('<font size="+1">新着ニュース</font>\r\n'))
            f.write(unicode('<ul>\r\n'))
            if latests:
                for id, weekd, news, newstime in latests:
                    f.write(unicode('<li><a href="%s%s%s&w=%s">%s</a></li>\r\n' \
                      % (NEWS_URL, u'index.php?d=', id, weekd, news)))
            else: #新着ニュースなし
                f.write(unicode('<li>%s</li>\r\n' \
                  % (("新着ニュースはありません"))))
            if lastnews: #前回までのニュースあり
                f.write(unicode('<br>----%s----<br>\r\n' \
                  % (("前回のニュース"))))
                for id, weekd, news, newstime in lastnews:
                    f.write(unicode('<li><a href="%s%s%s&w=%s">%s</a></li>\r\n' \
                      % (NEWS_URL, u'index.php?d=', id, weekd, news)))
            f.write(unicode('</ul>\r\n'))
            f.write(unicode('<hr />\r\n'))
            f.write(unicode('<p>'))
            f.write(unicode('<a href="./PyStation.html">戻る</a><br />\r\n'))
            f.write(unicode('<a href="%s">' % NEWS_URL))
            f.write(unicode('j-walkerモバイル ニュース</a>'))
#            f.write(unicode('</p>\r\n'))
#            f.write(unicode('<hr />\r\n'))
#            f.write(unicode('<p>更新時刻：%d月%d日　%d:%02d</p>\r\n' \
            f.write(unicode('<br><br>更新時刻：%d月%d日　%d:%02d\r\n' \
                             % (month, day, hour, minute)))
            f.write(unicode('</body>\r\n'))
            f.write(unicode('</html>'))
            f.close()
        except IOError:
            pass
        except:
            f.close()
            raise
    if latests:
        return latests[0][2]
    else:
        return ""

def format(news):
    """vCalendar形式に整形する"""
    import quopri
    year, month, day, hour, minute, sec = get_time()
    vcal = 'BEGIN:VCALENDAR\r\n'
    vcal += 'VERSION:1.0\r\n'
    vcal += 'BEGIN:VEVENT\r\n'
    vcal += 'DTSTART:%4d%02d%02dT000000\r\n' % (year, month, day)
    vcal += 'DTEND:%sT000000\r\n' \
             % tomorrow('%4d%02d%02d' % (year, month, day))
    vcal += 'SUMMARY;ENCODING=QUOTED-PRINTABLE;CHARSET=UTF-8:%s\r\n' \
             % quopri.encodestring(news).replace('=\n', '')
    vcal += 'UID:%s/%d\r\n' % (__scriptname__, 0)
    vcal += 'LAST-MODIFIED:%4d%02d%02dT%02d%02d%02d\r\n' \
             % (year, month, day, hour, minute, sec)
    vcal += 'TZ:+09\r\n'
    vcal += 'X-EPOCAGENDAENTRYTYPE:EVENT\r\n'
    vcal += 'CLASS:CONFIDENTIAL\r\n'
    vcal += 'SEQUENCE:0\r\n'
    vcal += 'X-METHOD:NONE\r\n'
    vcal += 'END:VEVENT\r\n'
    vcal += 'END:VCALENDAR'
    return vcal

def calendar(vcal):
    """カレンダーにインポート"""
    import calendar
    try:
        caldb = calendar.open()
        caldb.import_vcalendars(vcal)
    except:
        raise

def check_sig():
    """電波状況の確認"""
    import sysinfo
    try:
        sig = sysinfo.signal_bars()
    except:
        return 0
    else:
        if sig:
            return 1
        else:
            return 0

def get_time():
    """現在時刻の取得"""
    import time
    year = int(time.strftime('%Y', time.localtime()))
    month = int(time.strftime('%m', time.localtime()))
    day = int(time.strftime('%d', time.localtime()))
    hour = int(time.strftime('%H', time.localtime()))
    minute = int(time.strftime('%M', time.localtime()))
    sec = int(time.strftime('%S', time.localtime()))
    return (year, month, day, hour, minute, sec)

def tomorrow(today):
    """翌日の日付"""
    year = int(today[:4])
    month = int(today[4:6])
    day = int(today[6:])
    if day == 31 and month == 12:
        year += 1
        month = 1
        day = 1
    elif day == 31 and month in [1, 3, 5, 7, 8, 10]:
        month += 1
        day = 1
    elif day == 30 and month in [4, 6, 9, 11]:
        month += 1
        day = 1
    elif day == 29 and month == 2:
        month += 1
        day = 1
    elif day == 28 and month == 2 and not (year % 4) and (year % 100) or \
         not (year % 400):
        day += 1
    elif day == 28 and month == 2:
        month += 1
        day = 1
    else:
        day += 1
    return '%4d%02d%02d' % (year, month, day)

def notify():
    try:
        if os.path.isfile(SOUND_FILE):
            import sysinfo
            if sysinfo.ring_type() in ['normal', 'ascending', 'ring_once']:
                import audio
                def cb(prev, curr, err):
                    if curr == audio.EOpen: script_lock.signal()
                script_lock = e32.Ao_lock()
                s = audio.Sound.open(SOUND_FILE)
                s.set_volume(SOUND_VOL)
                s.play(1, 0, cb)
                script_lock.wait()
                s.close()
            else:
                try:
                    import misty
                    misty.vibrate(500, 50)
                except ImportError:
                    pass
                except SymbianError:
                    pass
        
        # 新着通知を表示
        if VIEW_QUERY:
            import globalui
            q = globalui.global_query(unicode('StationNews 新着情報\n確認しますか？'))
            if q:
                try:
                    e32.start_exe('Browser.exe',
                      ' "4 file://E:/Data/Hiisi/PyStation/PyStationNews.html"')
                except SymbianError:
                    e32.start_exe('BrowserNG.exe',
                      ' "4 file://E:/Data/Hiisi/PyStation/PyStationNews.html"')
    except:
        raise

def main():
    """メインの関数"""
    if check_sig():
        try:
            data = fetch()
            if data:
                news = parse(data)
                if news:
                    vcal = format(news)
                    if vcal:
                        if ADD_MEMO: calendar(vcal)
                        if NOTIFY_NEW:
                            if os.path.exists(OUT_FILE):
                                notify()
        except:
            raise

if __name__ == '__main__':
    main()

#    appuifw.app.set_exit()
#    sys.exit()
